package gg.malloc.defense.model;

import java.util.Collection;
import java.util.UUID;

import org.bukkit.entity.Player;

public interface Instance {
  public enum Stage {
    Idle,
    Warmup,
    Countdown,
    Playing,
    GameOver
  }

  UUID getId();
  Stage getStage();
  boolean requestTransition(Stage stage);
  State getState();
  void addPlayer(Player p);
  void removePlayer(Player p);
  Collection<Player> getPlayers();
  void togglePlayerReady(Player p);
  void spendMoney(Player p, int amount);
}
